#!/usr/local/bin/perl
# 
# ubbstats version 2
# David Campbell
# Many thanks to Charles Capps, Slurpee (Brett), Fredrico Carnales, Michael F and everyone else who helped with this 
# If you feel you have contributed but not been given credit please email me dave@cpfc.org
#
# This scriplet is a standalone addition to the Ultimate Bulletin Board by Infopop
#
# The scriptlet gathers a substantial amount of UBB statistics and writes them to the screen using the UBB styles file
#
# Requirements
# A full version of the UBB
# The ability to run Server Side Includes
#
# installation
# Save this file as ubbstats.pl
# Edit the file and change the two variables $MembersPath and $UBBPath
# Upload in ascii
# Chmod to 777
# Test by opening the file in your web browser or via telnet
# 
# Calling via ssi
# <!--#exec cgi="pathto your/cgi-bin/script.pl" -->
#
# No support is availabile for this scriplet although the UBB code hacking forum will be a good place to start if you have problems
#
# Enjoy 

# Standard Header
print ("Content-type: text/html\n\n");

# Please insert your members path below
$MembersPath = " ";


# Please insert your ubb path below
$UBBPath = " ";

## NB there is no need to edit any further unless you know what you are doing
## If you need to edit output scroll down to the print<<TOTALPOSTS; section

# Open the memberlist
open (MEMBFILE, "<$MembersPath/memberslist.cgi") or die ("Can't open file: $MembersPath/memberslist.cgi!");

# required files
require $UBBPath . "/UltBB.setup";
require $UBBPath . "/Styles.file";
require $UBBPath . "/ubb_library.pl";

# Initialise counts and variables
$num_threads = 1;
$cnt = 0;
$cntforums = 0;  
$TotPosts = 0;

# Bebin processing

## Total contributions
while ($line = <MEMBFILE> ) {
  chomp($line);
  ($name, $unknown, $userno) = split(/\|/, $line);
  open (USRFILE, "<$MembersPath/$userno.cgi") or die ("Can't open file: $MembersPath/userno.cgi!");
  for ($i=0; $i < 7; $i++) {
    $line = <USRFILE>;
    if ($i == 2) {$mailto = $line};
  }
  $place = $line;
  chomp($place);
  chomp($mailto);
  $line = <USRFILE>;
  $TotPosts += $line;
  $posts = sprintf("%7d", $line);
  for ($i=0; $i < 4; $i++) {
    $line = <USRFILE>;
  }
  close (USRFILE);
  $memblist[$cnt++];
}
close (MEMBFILE);

## Total members-
$NoMembers = $cnt;
@newlist = sort {$b cmp $a} @memblist;

@forumlines = ("");
open(FORUMS, "<$UBBPath/forums.cgi") || die "Could not open forums.cgi\n";
while(<FORUMS> )
 {
  push(@forumlines,$_);
  $cntforums++;
 }
close(FORUMS);
open (F,"$UBBPath/forums.cgi");
while (<F> ) {
	(@parts) = split(/\|/,$_);
        push @forums, $parts[8];
}
close F;

foreach $forum (@forums) {
	$filetoopen = $NonCGIPath . "/Forum" . $forum . "/forum" . $forum . ".threads";
	open (T,"$filetoopen");
	while (<T> ) {
		(@threads) = split(/\|/,$_);
		$numdate = $threads[10];
		$year = substr ($numdate,0,4);
		$month = substr ($numdate,4,2);
		$day = substr ($numdate,6,2);
		$hour = substr ($numdate,8,2);
		$min = substr ($numdate,10,2);

@months = ("","January","February","March","April","May","June","July","August","September","October","November","December");
             $ExpandedMonth = $months[$month];
             $Date = "$ExpandedMonth $day, $year at $hour:$min";

		$ordered = "$threads[10]|$threads[4]|$threads[2]|$Date|$forum";
		push @allthreads, $ordered;
	}
	close T;
}


@sortedthreads = sort {$b cmp $a} @allthreads;

$x = 0;

for (@sortedthreads) {
	$x++;
	unless ($x > $num_threads) {
		(@threaddata) = split(/\|/,$_);

        }
}

# Featured member (calls a random member) - Kudos Fredrico
open (F,"$MembersPath/memberslist.cgi");
@members = <F>;
close F;

$featured = $members[int(rand(@members))];
(@member) = split(/\|/,$featured);
chomp($member[2]);
$filetoopen = $member[2] . ".cgi";

open (M,"$MembersPath/$filetoopen");
while (<M>) {
	chomp;
	push @mdata, $_;
}
close M;

#last member sub- kudos to Slurpee

@lastmember = reverse(@members);
$LastReg = $lastmember[0];
($user,$number)=split(/\|\!\!\|/,$LastReg);
$LastRegCoded = $LastReg;
chomp($LastReg);
($username,$junk,$number)=split(/\|/,$LastReg);

eval {
($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
};

##CC hack acurate posts/topics count- Kudos Charles
&ReadParse;
 @allforums = &OpenForumsFile;
@forums = @blank;

#make sure only open forums are listed in @forums
foreach $ifopen(@allforums) {
chomp($ifopen);
@checkit = split(/\|/, $ifopen);
if ($checkit[3] eq "On") {
	push (@forums, $ifopen);
}
}

for $each(@forums) {

@thisforuminfo = split(/\|/, $each);
chomp($thisforuminfo[8]);
$x = "$thisforuminfo[8]";

if ($thisforuminfo[6] eq "private") {
	$ExactPath = "Forum$x/private-$thisforuminfo[7]";
}  else {
	$ExactPath = "Forum$x";
}


my @data = &OpenFile("$ForumsPath/$ExactPath/lastnumber.file");

$TotalTopics = $data[1];
chomp($TotalTopics);
$TotalPosts = $data[2];
chomp($TotalPosts);

if ($TotalTopics eq "") {
	$TotalTopics = "0";
	}
	
if ($TotalPosts eq "") {
	$TotalPosts = "0";
	}

## Final variables to call later accurate posts/accurate topics
$AbsTopics = $AbsTopics + $TotalTopics;
$AbsPosts = $AbsPosts + $TotalPosts;
}
## End ACCURATE total posts


## If you want to omit any of the data passed feel free to edit
print<<TOTALPOSTS;
<html>
<head>
<TITLE>$BBName - powered by the Ultimate Bulletin Board</title>
</head>
<BODY bgcolor="$BGColor" $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>
<FONT FACE="$FontFace" SIZE="$TextSize">
<center>
<table cellspacing="0" border="1" bordercolor="$TableBorderColor" width="50%">
    <tr>
      <td width="100%" bgcolor="$AltColumnColor1" colspan="2" valign="top"><font face="$FontFace" size="$TextSize" color="$TextColor"><a href="$CGIURL/Ultimate.cgi"><B><Center>$BBName</Center></a></font></b></td>
    </tr>
    <tr>
      <td width="100%" bgcolor="$AltColumnColor2" colspan="2" valign="top" ><font face="$FontFace" size="$FDTextSize" color="$TextColor">There are currently <B>$NoMembers</B>
        members</font></td>
    </tr>
    <tr>
      <td width="100%" bgcolor="$AltColumnColor1" colspan="2" valign="top"><font face="$FontFace" size="$FDTextSize" color="$TextColor"> &nbsp; <B>$TotPosts</B> contributions
        in <B>$cntforums</B> forums</font></td>
    </tr>
    <tr>
      <td width="50%" bgcolor="$AltColumnColor2" valign="top" ><font face="$FontFace" size="$FDTextSize" color="$TextColor"> <B>$AbsTopics</B> active topics</font></td>
    </tr>
    <tr>
      <td width="50%" bgcolor="$AltColumnColor1" valign="top" ><font face="$FontFace" size="$FDTextSize" color="$TextColor"><b>$AbsPosts</b>
        active posts</font></td>
    </tr>
    <tr>
      <td width="100%" bgcolor="$AltColumnColor2" colspan="2" valign="top"><font face="$FontFace" size="$FDTextSize" color="$TextColor">Last post <B> <a href="$NonCGIURL/Forum$threaddata[4]/HTML/$threaddata[2].html">
$threaddata[3]</A></B></font></td>
    </tr>
    <tr>
      <td width="100%" bgcolor="$AltColumnColor1" colspan="2" valign="top" ><font face="$FontFace" size="$FDTextSize" color="$TextColor">Todays featured member is <B><a href="$CGIURL/ubbmisc.cgi?action=getbio&UserName=$mdata[0]">$mdata[0]</a></B></font></td>
    </tr>
    <tr>
      <td width="100%" bgcolor="$AltColumnColor2" colspan="2" valign="top" ><font face="$FontFace" size="$FDTextSize" color="$TextColor">Last member to register is <B><a href="$CGIURL/ubbmisc.cgi?action=getbio&UserName=$username">$username</a></B></font></td>
    </tr>
  </table>
TOTALPOSTS
</html>




